=== examples/algo/CMakeLists.txt ===
############################################################################
#  examples/algo/CMakeLists.txt
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

stxxl_build_example(copy_and_sort_file)
stxxl_build_example(phonebills)
stxxl_build_example(phonebills_genlog)
stxxl_build_example(sort_file)
