=== examples/containers/CMakeLists.txt ===
############################################################################
#  examples/containers/CMakeLists.txt
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2013-2014 Timo Bingmann <tb@panthema.net>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

stxxl_build_example(copy_file)
stxxl_build_example(deque1)
stxxl_build_example(deque2)
stxxl_build_example(map1)
stxxl_build_example(matrix1)
stxxl_build_example(pqueue1)
stxxl_build_example(pqueue2)
stxxl_build_example(queue1)
stxxl_build_example(queue2)
stxxl_build_example(sequence1)
stxxl_build_example(sorter1)
stxxl_build_example(sorter2)
stxxl_build_example(stack1)
stxxl_build_example(stack2)
stxxl_build_example(unordered_map1)
stxxl_build_example(vector1)
stxxl_build_example(vector2)
stxxl_build_example(vector_buf)

stxxl_test(deque1)
stxxl_test(deque2)
stxxl_test(map1)
stxxl_test(matrix1)
stxxl_test(pqueue1)
stxxl_test(pqueue2)
stxxl_test(queue1)
stxxl_test(queue2)
stxxl_test(sequence1)
stxxl_test(sorter1)
stxxl_test(sorter2)
stxxl_test(stack1)
stxxl_test(stack2)
stxxl_test(unordered_map1)
stxxl_test(vector1)
stxxl_test(vector2)
stxxl_test(vector_buf)
