=== debian/changelog ===
libstxxl (1.4.1-6) unstable; urgency=medium

  * No changes upload.

 -- Anton Gladky <gladk@debian.org>  Fri, 10 Oct 2025 21:40:31 +0200

libstxxl (1.4.1-5) unstable; urgency=medium

  [ Debian Janitor ]
  * [ecf9a24] Apply multi-arch hints. + libstxxl-doc: Add Multi-Arch: foreign.

  [ Anton Gladky ]
  * [60d0282] Update changelog.
  * [63bd569] fix(debian): Raise minimal CMake version (Closes: #1113207)
  * [839192a] chore(debian): Update Standards-Version to 4.7.2

 -- Anton Gladky <gladk@debian.org>  Thu, 09 Oct 2025 21:13:09 +0200

libstxxl (1.4.1-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062642

 -- Graham Inggs <ginggs@debian.org>  Wed, 28 Feb 2024 19:09:19 +0000

libstxxl (1.4.1-4) unstable; urgency=medium

  * [fe2eba4] Add .gitlab-ci.yml.
  * [3c8b84c] Disable pdf build. (Closes: #1051165)
  * [6a530dc] Trim trailing whitespace.
  * [2bf9fcd] Update watch file format version to 4.
  * [aeff07a] Bump debhelper from old 11 to 13.
  * [48b1e14] Set debhelper-compat version in Build-Depends.
  * [0151f9e] Fix day-of-week for changelog entry 1.3.1-4.
  * [2aa4f8a] Remove field Priority on binary packages
              libstxxl-dev, libstxxl-doc, libstxxl1-bin that duplicates source.
  * [7ec46e6] Set Recommends-Versions to 4.6.2.
  * [5ccf28b] Apply cme fix dpkg.
  * [45b9d3f] Add myself as uploader.

 -- Anton Gladky <gladk@debian.org>  Fri, 15 Sep 2023 19:36:33 +0200

libstxxl (1.4.1-3) unstable; urgency=medium

  * Team upload.
  * [973f16b] Switch to compat level 11
  * [76a40a5] Update VCS-fields
  * [d0e648e] Remove outdated Testsuite-field
  * [c26df19] Set Standards-Version: 4.1.3
  * [8973044] Apply cme fix dpkg
  * [c3b6b0a] Replace priority extra by optional
  * [832b6c2] Drop dbg-package
  * [de76517] Remove myself from uploaders

 -- Anton Gladky <gladk@debian.org>  Thu, 08 Mar 2018 21:01:26 +0100

libstxxl (1.4.1-2) unstable; urgency=medium

  [ Anton Gladky ]
  * [10bbced] Apply cme fix dpkg-control.
  * [2da8441] Add a description to patch.
  * [c9f296e] Remove unneded lintian-overrides.
  * [23d7673] Rename shared lib due to GCC-5 transition. (Closes: #791173)
  * [0105031] Use DEP-5 for d/copyright.

  [ Bas Couwenberg ]
  * Use versioned Breaks/Replaces.

 -- Anton Gladky <gladk@debian.org>  Sun, 23 Aug 2015 17:00:29 +0200

libstxxl (1.4.1-1) unstable; urgency=medium

  [ D Haley ]
  * [7d8f358] Imported Upstream version 1.4.1
  * [69811b5] Refresh patches
  * [d8eca54] Update standards version

  [ Anton Gladky ]
  * [066a810] Fix bugnumber.
  * [5e7edbb] Remove timestamp from HTML doxygen build.

 -- Anton Gladky <gladk@debian.org>  Sun, 17 May 2015 22:18:32 +0200
