=== debian/control ===
Source: libstxxl
Standards-Version: 4.7.2
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 D Haley <mycae@gmx.com>,
 Anton Gladky <gladk@debian.org>,
Section: science
Priority: optional
Build-Depends:
 dpkg-dev (>= 1.22.5),
 cmake,
 debhelper-compat (= 13),
 doxygen,
 doxygen-latex,
 ghostscript,
 graphviz,
 texlive-fonts-extra,
 texlive-fonts-recommended,
 texlive-latex-extra,
 texlive-latex-recommended,
Vcs-Browser: https://salsa.debian.org/science-team/libstxxl
Vcs-Git: https://salsa.debian.org/science-team/libstxxl.git
Homepage: http://stxxl.sourceforge.net

Package: libstxxl-dev
Architecture: any
Section: libdevel
Depends:
 libstxxl1t64 (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 libstxxl-doc,
Description: Development libraries for STXXL
 STXXL provides an STL replacement using an abstraction layer to
 storage devices to allow for the optimal layout of data structures. This
 allows for multi-terabyte datasets to be held and manipulated in standard
 C++ data structures, whilst abstracting the complexity of managing this
 behaviour efficiently. STXXL utilises multi-disk I/O to speed up
 I/O bound calculations. STXXL has been developed at the University
 of Karlsruhe.
 .
 Development libraries for STXXL, required for building programs that
 utilise the STXXL library

Package: libstxxl-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends},
 libjs-jquery,
Description: Documentation for STXXL
 STXXL provides an STL replacement using an abstraction layer to
 storage devices to allow for the optimal layout of data structures. This
 allows for multi-terabyte datasets to be held and manipulated in standard
 C++ data structures, whilst abstracting the complexity of managing this
 behaviour efficiently. STXXL utilises multi-disk I/O to speed up
 I/O bound calculations. STXXL has been developed at the University
 of Karlsruhe.
 .
 Documentation for the STXXL library.

Package: libstxxl1t64
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libstxxl1v5 (<< ${source:Version}),
 libstxxl1 (<< 1.4.1-2~),
Provides:
 ${t64:Provides},
Replaces:
 libstxxl1v5,
 libstxxl1 (<< 1.4.1-2~),
Description: C++ Standard Template Library for extra large datasets
 STXXL provides an STL replacement using an abstraction layer to
 storage devices to allow for the optimal layout of data structures. This
 allows for multi-terabyte datasets to be held and manipulated in standard
 C++ data structures, whilst abstracting the complexity of managing this
 behaviour efficiently. STXXL utilises multi-disk I/O to speed up
 I/O bound calculations. STXXL has been developed at the University
 of Karlsruhe.
X-Time64-Compat: libstxxl1v5

Package: libstxxl1-bin
Architecture: any
Section: misc
Depends:
 libstxxl1t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: STXXL File creation and benchmark tool
 STXXL provides an STL replacement using an abstraction layer to
 storage devices to allow for the optimal layout of data structures. This
 allows for multi-terabyte datasets to be held and manipulated in standard
 C++ data structures, whilst abstracting the complexity of managing this
 behaviour efficiently. STXXL utilises multi-disk I/O to speed up
 I/O bound calculations. STXXL has been developed at the University
 of Karlsruhe.
 .
 A benchmarking tool and STXXL on-disk file administration utility
