=== debian/watch ===
version=4
http://sf.net/stxxl stxxl-([0-9].+[0-9])\.tar\.gz
